Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/MedianPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/MedianPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/MedianPushData.cs	(revision 14602)
@@ -0,0 +1,33 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class MedianPushData : Data<long[], long>, IPushData {
+    public MedianPushData(Example<long[], long>[] training, Example<long[], long>[] test)
+      : base(training, test, 0, 100) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/MirrorImagePushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/MirrorImagePushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/MirrorImagePushData.cs	(revision 14602)
@@ -0,0 +1,35 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class MirrorImagePushData : Data<long[][], bool>, IPushData {
+    public MirrorImagePushData(Example<long[][], bool>[] training, Example<long[][], bool>[] test)
+      : base(training, test, 0, 50) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Training[index].Input[0]);
+      interpreter.IntegerStack.Push(Training[index].Input[1]);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Test[index].Input[0]);
+      interpreter.IntegerStack.Push(Test[index].Input[1]);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.BooleanStack,
+        index,
+        this.Training,
+        data => data == interpreter.BooleanStack.Top ? 1 : 0);
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.BooleanStack,
+        index,
+        this.Test,
+        data => data == interpreter.BooleanStack.Top ? 1 : 0);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/NegativeToZeroPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/NegativeToZeroPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/NegativeToZeroPushData.cs	(revision 14602)
@@ -0,0 +1,33 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class NegativeToZeroPushData : Data<long[], long[]>, IPushData {
+    public NegativeToZeroPushData(Example<long[], long[]>[] training, Example<long[], long[]>[] test)
+      : base(training, test, 0, 50) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/NumberIoPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/NumberIoPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/NumberIoPushData.cs	(revision 14602)
@@ -0,0 +1,36 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class NumberIoPushData : Data<double[], double>, IPushData {
+    public NumberIoPushData(Example<double[], double>[] training, Example<double[], double>[] test)
+      : base(training, test, 0, 200) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.FloatStack.Push(Training[index].Input[0]);
+      interpreter.IntegerStack.Push((long)Training[index].Input[1]);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.FloatStack.Push(Test[index].Input[0]);
+      interpreter.IntegerStack.Push((long)Test[index].Input[1]);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.FloatStack,
+        index,
+        this.Training,
+        data => GetFloatResultDifference(data, interpreter.FloatStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.FloatStack,
+        index,
+        this.Test,
+        data => GetFloatResultDifference(data, interpreter.FloatStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/PigLatinPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/PigLatinPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/PigLatinPushData.cs	(revision 14602)
@@ -0,0 +1,35 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class PigLatinPushData : Data<string, string>, IPushData {
+    public PigLatinPushData(Example<string, string>[] training, Example<string, string>[] test)
+      : base(training, test, 0, 128 * 70) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      var asciiValues = GetAsciiValues(this.Training[index].Input);
+      interpreter.IntegerStack.Push(asciiValues);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      var asciiValues = GetAsciiValues(this.Training[index].Input);
+      interpreter.IntegerStack.Push(asciiValues);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/ReplaceSpaceWithNewLinePushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/ReplaceSpaceWithNewLinePushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/ReplaceSpaceWithNewLinePushData.cs	(revision 14602)
@@ -0,0 +1,41 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class ReplaceSpaceWithNewlinePushData : Data<string, string[]>, IPushData {
+    public ReplaceSpaceWithNewlinePushData(Example<string, string[]>[] training, Example<string, string[]>[] test)
+      : base(training, test, 0, 128 * 70) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      var asciiValues = GetAsciiValues(this.Training[index].Input);
+      interpreter.IntegerStack.Push(asciiValues);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      var asciiValues = GetAsciiValues(this.Training[index].Input);
+      interpreter.IntegerStack.Push(asciiValues);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data =>
+          GetIntResultDifference(int.Parse(data[1]), interpreter.IntegerStack) +
+          data[0].CompareTo(interpreter.NameStack.Top)
+        );
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data =>
+          GetIntResultDifference(int.Parse(data[1]), interpreter.IntegerStack) +
+          data[0].CompareTo(interpreter.NameStack.Top)
+        );
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Checksum.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Checksum.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Checksum.cs	(revision 14602)
@@ -0,0 +1,25 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class Checksum : BenchmarkSuiteDataDescriptor<string, string> {
+    private const string displayMame = "Checksum";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override string ConvertInput(string[] input) {
+      return input[0];
+    }
+
+    public override string ConvertOutput(string[] output) {
+      return output[0];
+    }
+
+    public override IPushData CreatePushData(Example<string, string>[] training, Example<string, string>[] test) {
+      return new ChecksumPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CollatzNumbers.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CollatzNumbers.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CollatzNumbers.cs	(revision 14602)
@@ -0,0 +1,25 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class CollatzNumbers : BenchmarkSuiteDataDescriptor<long, long> {
+    private const string displayMame = "Collatz Numbers";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override long ConvertInput(string[] input) {
+      return ConvertInteger(input[0]);
+    }
+
+    public override long ConvertOutput(string[] output) {
+      return ConvertInteger(output[0]);
+    }
+
+    public override IPushData CreatePushData(Example<long, long>[] training, Example<long, long>[] test) {
+      return new CollatzNumbersPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CompareStringLengths.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CompareStringLengths.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CompareStringLengths.cs	(revision 14602)
@@ -0,0 +1,25 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class CompareStringLengths : BenchmarkSuiteDataDescriptor<string[], bool> {
+    private const string displayMame = "Compare String Lengths";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+    protected override int InputCount { get { return 3; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override string[] ConvertInput(string[] input) {
+      return input;
+    }
+
+    public override bool ConvertOutput(string[] output) {
+      return ConvertBool(output[0]);
+    }
+
+    public override IPushData CreatePushData(Example<string[], bool>[] training, Example<string[], bool>[] test) {
+      return new CompareStringLengthsPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs	(revision 14602)
@@ -1,141 +1,25 @@
-﻿namespace HeuristicLab.BenchmarkSuite.Problems
-{
-  using System.Collections.Generic;
-  using System.Linq;
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
 
-  public class CountOdds : BenchmarkSuiteDataDescritpor<List<int>>
-  {
-    public const int MaxOdd = 999;
+  public class CountOdds : BenchmarkSuiteDataDescriptor<long[], long> {
+    private const string displayMame = "Count Odds";
+    private const string description = "";
 
-    public const int MaxEven = 1000;
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
 
-    public const int MaxRandom = 1000;
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 1; } }
 
-    public const int MinRandom = 1000;
-
-    public const int MaxVectorLength = 50;
-
-    public override string Description
-    {
-      get
-      {
-        return string.Empty;
-      }
+    public override long[] ConvertInput(string[] input) {
+      return ConvertIntegers(input[0]);
     }
 
-    public override string Name
-    {
-      get
-      {
-        return "Count Odds";
-      }
+    public override long ConvertOutput(string[] output) {
+      return ConvertInteger(output[0]);
     }
 
-    protected override IEnumerable<Example> GenerateExamples(IEnumerable<List<int>> inputData)
-    {
-      foreach (var input in inputData)
-        yield return
-          new Example
-            {
-              Input = string.Format("[{0}]", string.Join(", ", input)),
-              Output = input.Count(x => x % 2 == 1).ToString()
-            };
-    }
-
-    protected override IEnumerable<List<int>> GenerateTest()
-    {
-      foreach (var list in this.GetHardcodedTrainingSamples()) yield return list;
-
-      foreach (var list in this.GetAllOdd(100)) yield return list;
-
-      foreach (var list in this.GetAllEven(100)) yield return list;
-
-      foreach (var list in this.GetRandom(1800)) yield return list;
-    }
-
-    protected override IEnumerable<List<int>> GenerateTraining()
-    {
-      foreach (var list in this.GetHardcodedTrainingSamples()) yield return list;
-
-      foreach (var list in this.GetAllOdd(9)) yield return list;
-
-      foreach (var list in this.GetAllEven(9)) yield return list;
-
-      foreach (var list in this.GetRandom(150)) yield return list;
-    }
-
-    private IEnumerable<List<int>> GetAllOdd(int n)
-    {
-      for (var i = 0; i < n; i++)
-      {
-        var length = rand.Next(0, MaxVectorLength);
-        var vector = new List<int>(length);
-
-        for (var j = 0; j < length; j++) vector.Add(rand.Next(0, MaxOdd) * 2 - MaxOdd);
-
-        yield return vector;
-      }
-    }
-
-    private IEnumerable<List<int>> GetAllEven(int n)
-    {
-      for (var i = 0; i < n; i++)
-      {
-        var length = rand.Next(0, MaxVectorLength);
-        var vector = new List<int>(length);
-
-        for (var j = 0; j < length; j++) vector.Add(rand.Next(0, MaxEven) * 2 - MaxEven);
-
-        yield return vector;
-      }
-    }
-
-    private IEnumerable<List<int>> GetRandom(int n)
-    {
-      for (var i = 0; i < n; i++)
-      {
-        var length = rand.Next(0, MaxVectorLength);
-        var vector = new List<int>(length);
-
-        for (var j = 0; j < length; j++) vector.Add(rand.Next(MinRandom, MaxRandom));
-
-        yield return vector;
-      }
-    }
-
-    private IEnumerable<List<int>> GetHardcodedTrainingSamples()
-    {
-      yield return new List<int>();
-      yield return new List<int> { -10 };
-      yield return new List<int> { -9 };
-      yield return new List<int> { -8 };
-      yield return new List<int> { -7 };
-      yield return new List<int> { -6 };
-      yield return new List<int> { -5 };
-      yield return new List<int> { -4 };
-      yield return new List<int> { -3 };
-      yield return new List<int> { -2 };
-      yield return new List<int> { -1 };
-      yield return new List<int> { -0 };
-      yield return new List<int> { 1 };
-      yield return new List<int> { 2 };
-      yield return new List<int> { 3 };
-      yield return new List<int> { 4 };
-      yield return new List<int> { 5 };
-      yield return new List<int> { 6 };
-      yield return new List<int> { 7 };
-      yield return new List<int> { 8 };
-      yield return new List<int> { 9 };
-      yield return new List<int> { 10 };
-      yield return new List<int> { -947 };
-      yield return new List<int> { -450 };
-      yield return new List<int> { 303 };
-      yield return new List<int> { 886 };
-      yield return new List<int> { 0, 0 };
-      yield return new List<int> { 0, 1 };
-      yield return new List<int> { 7, 1 };
-      yield return new List<int> { -9, -1 };
-      yield return new List<int> { -11, 40 };
-      yield return new List<int> { 944, 77 };
+    public override IPushData CreatePushData(Example<long[], long>[] training, Example<long[], long>[] test) {
+      return new CountOddsPushData(training, test);
     }
   }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Digits.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Digits.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Digits.cs	(revision 14602)
@@ -0,0 +1,30 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class Digits : BenchmarkSuiteDataDescriptor<long, long[]> {
+    private const string displayMame = "Digits";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override long ConvertInput(string[] input) {
+      return ConvertInteger(input[0]);
+    }
+
+    public override long[] ConvertOutput(string[] output) {
+      return SplitByNewLine(output[0])
+        .Select(ConvertInteger)
+        .ToArray();
+    }
+
+    public override IPushData CreatePushData(Example<long, long[]>[] training, Example<long, long[]>[] test) {
+      return new DigitsPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/DoubleLetters.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/DoubleLetters.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/DoubleLetters.cs	(revision 14602)
@@ -0,0 +1,25 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class DoubleLetters : BenchmarkSuiteDataDescriptor<string, string> {
+    private const string displayMame = "Double Letters";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override string ConvertInput(string[] input) {
+      return input[0];
+    }
+
+    public override string ConvertOutput(string[] output) {
+      return output[0];
+    }
+
+    public override IPushData CreatePushData(Example<string, string>[] training, Example<string, string>[] test) {
+      return new DoubleLettersPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/EvenSquares.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/EvenSquares.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/EvenSquares.cs	(revision 14602)
@@ -0,0 +1,30 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class EvenSquares : BenchmarkSuiteDataDescriptor<long, long[]> {
+    private const string displayMame = "Even Squares";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override long ConvertInput(string[] input) {
+      return ConvertInteger(input[0]);
+    }
+
+    public override long[] ConvertOutput(string[] output) {
+      return SplitByNewLine(output[0])
+        .Select(ConvertInteger)
+        .ToArray();
+    }
+
+    public override IPushData CreatePushData(Example<long, long[]>[] training, Example<long, long[]>[] test) {
+      return new EvenSquaresPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/ForLoopIndex.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/ForLoopIndex.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/ForLoopIndex.cs	(revision 14602)
@@ -0,0 +1,30 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class ForLoopIndex : BenchmarkSuiteDataDescriptor<long[], long[]> {
+    private const string displayMame = "For Loop Index";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+
+    protected override int InputCount { get { return 3; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override long[] ConvertInput(string[] input) {
+      return input.Select(ConvertInteger).ToArray();
+    }
+
+    public override long[] ConvertOutput(string[] output) {
+      return SplitByNewLine(output[0])
+        .Select(ConvertInteger)
+        .ToArray();
+    }
+
+    public override IPushData CreatePushData(Example<long[], long[]>[] training, Example<long[], long[]>[] test) {
+      return new ForLoopIndexPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Grades.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Grades.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Grades.cs	(revision 14602)
@@ -0,0 +1,26 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class Grades : BenchmarkSuiteDataDescriptor<long[], string> {
+    private const string displayMame = "Checksum";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+    protected override int InputCount { get { return 5; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override long[] ConvertInput(string[] input) {
+      return input.Select(ConvertInteger).ToArray();
+    }
+
+    public override string ConvertOutput(string[] output) {
+      return output[0];
+    }
+
+    public override IPushData CreatePushData(Example<long[], string>[] training, Example<long[], string>[] test) {
+      return new GradePushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/LastIndexOfZero.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/LastIndexOfZero.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/LastIndexOfZero.cs	(revision 14602)
@@ -0,0 +1,26 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class LastIndexOfZero : BenchmarkSuiteDataDescriptor<long[], long> {
+    private const string displayMame = "Last Index of Zero";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override long[] ConvertInput(string[] input) {
+      return ConvertIntegers(input[0]);
+    }
+
+    public override long ConvertOutput(string[] output) {
+      return ConvertInteger(output[0]);
+    }
+
+    public override IPushData CreatePushData(Example<long[], long>[] training, Example<long[], long>[] test) {
+      return new LastIndexOfZeroPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Median.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Median.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/Median.cs	(revision 14602)
@@ -0,0 +1,28 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class Median : BenchmarkSuiteDataDescriptor<long[], long> {
+    private const string displayMame = "Median";
+    private const string description = "";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+
+    protected override int InputCount { get { return 3; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override long[] ConvertInput(string[] input) {
+      return input.Select(ConvertInteger).ToArray();
+    }
+
+    public override long ConvertOutput(string[] output) {
+      return ConvertInteger(output[0]);
+    }
+
+    public override IPushData CreatePushData(Example<long[], long>[] training, Example<long[], long>[] test) {
+      return new MedianPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/MirrorImage.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/MirrorImage.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/MirrorImage.cs	(revision 14602)
@@ -0,0 +1,28 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class MirrorImage : BenchmarkSuiteDataDescriptor<long[][], bool> {
+    private const string displayMame = "Mirror Image";
+    private const string description = "Given two vectors of integers, return true if one vector is the reverse of the other, and false otherwise";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+
+    protected override int InputCount { get { return 2; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override long[][] ConvertInput(string[] input) {
+      return input.Select(ConvertIntegers).ToArray();
+    }
+
+    public override bool ConvertOutput(string[] output) {
+      return ConvertBool(output[0]);
+    }
+
+    public override IPushData CreatePushData(Example<long[][], bool>[] training, Example<long[][], bool>[] test) {
+      return new MirrorImagePushData(training, test);
+    }
+  }
+}
